<?php

namespace app\enterprise\controller;

use app\enterprise\common\EnterpriseController;
use app\enterprise\api\TalentApi;
use app\enterprise\model\Talent as TalentModel;
use think\facade\Db;
use think\facade\Log;
use app\common\api\EnterpriseApi;
use app\common\api\DictApi;
use app\common\api\TalentLogApi;
use app\common\api\TalentState;
use think\exception\ValidateException;
use app\enterprise\validate\TalentInfo;

// 0正在填写 1保存未提交 2已提交未审核 3已审核 4驳回 5保存补充材料未提交 6提交补充材料进入初审 7初审通过 8初审驳回 9部门审核通过 10部门审核驳回 11复核通过 12复核驳回 13复核失败

/**
 * Description of Talent
 *
 * @author sgq
 */
class Talent extends EnterpriseController {

    public function index() {
        $isMix = $this->request->param("isMix");
        $tpl = "";
        if ($isMix == 1) {
            $tpl = "newIndex";
        }
        return view($tpl);
    }

    public function list() {
        $step = 2;
        $res = TalentApi::getList($this->request, $step);
        return json($res);
    }

    public function zrIndex() {
        return view();
    }

    /**
     * 新人才申报企业端统一申报入口，混合基础信息及人才信息
     */
    public function apply(\think\Request $request) {
        $type = $this->user["type"];
        $tpl = "";
        switch ($type) {
            case 1:
                $tpl = "apply"; //晋江人才
                break;
            case 2:
                $tpl = "ic_apply"; //集成电路
                break;
        }
        $param = $request->param();
        $id = isset($param["id"]) ? $param["id"] : 0;
        $info = \app\common\api\VerifyApi::getTalentInfoById($id);
        if ($info["isImport"]) {
            //$tpl = "no_file_apply"; //晋江人才
        }
        $ep = EnterpriseApi::getOne($this->user["uid"]);
        if (!chkEnterpriseFull($ep))
            return;
        $tagList = DictApi::selectByParentCode('enterprise_tag');
        $streetList = DictApi::selectByParentCode('street');
        $industryFieldNew = DictApi::selectByParentCode('industry_field');
        $ep->enterpristTagName = $tagList[$ep->enterpriseTag];
        $ep->streetName = $streetList[$ep->street];
        $ep->industryFieldNewName = $industryFieldNew[$ep->industryFieldNew];
        if ($info) {
            $info["real_state"] = TalentLogApi::getLastLog($id, 1)["state"];
        }
        if ($info && in_array($info["checkState"], [TalentState::FST_VERIFY_PASS, TalentState::DEPT_VERIFY_PASS, TalentState::REVERIFY_PASS, TalentState::REVERIFY_FAIL])) {
            return $this->view($request);
            exit();
        }
        if ($request->isPost()) {
            $checkState = $info["checkState"] ?: 0;
            if ($checkState == TalentState::SCND_SAVE || $checkState == 0) {
                switch ($type) {
                    case 1:
                        $this->mixSave($info, $request, TalentState::SCND_SAVE);
                        exit();
                        break;
                    case 2:
                        $this->icSave($info, $request, TalentState::SCND_SAVE);
                        exit();
                        break;
                }
            } else if (in_array($checkState, [TalentState::BASE_VERIFY_FAIL, TalentState::BASE_REVERIFY_FAIL, TalentState::FST_VERIFY_FAIL, TalentState::REVERIFY_FAIL])) {
                $res = ["msg" => "审核失败，不能再保存"];
                echo sprintf("<script>parent.TalentInfoInfoDlg.infoCallback(%s);</script>", json_encode($res));
                exit;
            }
            $res = ["msg" => "已提交审核，请耐心等待"];
            echo sprintf("<script>parent.TalentInfoInfoDlg.infoCallback(%s);</script>", json_encode($res));
            exit;
        }
        $checkState = $info["checkState"] ?: 0;

        $batch = \app\common\api\BatchApi::getValidBatch(\app\common\state\ProjectState::TALENT, $this->user["type"]);
        $info["enterprise"] = $ep;
        $info["talent_type_list"] = DictApi::findChildDictByCode("talent_type");
        if ($info["talent_condition"]) {
            $info["isSalary"] = \app\common\api\TalentConditionApi::getOne($info["talent_condition"])["isSalary"] ?: 0;
        }
        return view($tpl, ["year" => $batch["batch"], "checkState" => $checkState, "row" => $info]);
    }

    /**
     * 旧第二步
     * @param \think\Request $request
     * @return type
     */
    public function second(\think\Request $request) {
        if ($this->user["type"] != 1)
            return "此入口仅供晋江市人才申报，晋江集成电路人才请使用新统一申报入口";
        $params = $request->param();
        $id = $params["id"];
        $info = \app\common\api\VerifyApi::getTalentInfoById($id);
        $info["real_state"] = TalentLogApi::getLastLog($id, 1)["state"];
        if ($request->isPost()) {
            if (!$info || $info["enterprise_id"] != $this->user["uid"]) {
                $res = ["msg" => "没有对应的人才认定申报信息"];
                echo sprintf("<script>parent.TalentInfoInfoDlg.infoCallback(%s);</script>", json_encode($res));
                exit;
            }
            $checkState = $info["checkState"];
            if ($checkState == TalentState::SCND_SAVE || $checkState == TalentState::BASE_REVERIFY_PASS) {
                $this->save($info, $request, TalentState::SCND_SAVE);
                exit();
            } else if (in_array($checkState, [TalentState::BASE_VERIFY_FAIL, TalentState::BASE_REVERIFY_FAIL, TalentState::FST_VERIFY_FAIL, TalentState::REVERIFY_FAIL])) {
                $res = ["msg" => "审核失败，不能再保存"];
                echo sprintf("<script>parent.TalentInfoInfoDlg.infoCallback(%s);</script>", json_encode($res));
                exit;
            }
            $res = ["msg" => "已提交审核，请耐心等待"];
            echo sprintf("<script>parent.TalentInfoInfoDlg.infoCallback(%s);</script>", json_encode($res));
            exit;
        }
        $enterprise_info = \app\common\model\Enterprise::find($this->user["uid"]);
        $info["enterprise"] = $enterprise_info;
        $batch = \app\common\api\BatchApi::getValidBatch(1, $enterprise_info["type"]);
        return view("second", ["year" => $info["apply_year"] ?: $batch["batch"], "row" => $info]);
    }

    public function view(\think\Request $request) {
        switch ($this->user["type"]) {
            case 1:
                $tpl = "view"; //晋江人才
                break;
            case 2:
                $tpl = "ic_view"; //集成电路
                break;
        }
        $id = $request->param("id");
        $info = \app\common\api\VerifyApi::getTalentInfoById($id);
        if ($info["isImport"]) {
            //$tpl = "no_file_view";
        }
        return view($tpl, ["row" => $info]);
    }

    /**
     * 提交表单（旧第二步）
     */
    public function submit() {
        $params = $this->request->param();
        $id = $params["id"];
        if (!$info = TalentApi::chkIsOwner($id, $this->user["uid"])) {
            $res = ["msg" => "没有对应的人才认定申报信息"];
            echo sprintf("<script>parent.TalentInfoInfoDlg.submitCallback(%s);</script>", json_encode($res));
            exit;
        }
        if ($info) {
            $info["real_state"] = TalentLogApi::getLastLog($id, 1)["state"];
        }
        $checkState = $info["checkState"];
        if ($checkState == TalentState::SCND_SAVE || $checkState == TalentState::BASE_REVERIFY_PASS) {
            $field_dict = \app\common\api\DictApi::getTalentFields(2);

            $no_empty = ["talent_arrange", "talent_condition", "highest_degree", "graduate_school", "major", "bank", "bank_number", "bank_branch_name",
                "bank_account", "study_abroad", "phone", "email", "import_way", "cur_entry_time", "cur_entry_time", "position", "source"];

            $where = [];
            $where[] = ["rel", "=", "study_abroad"];
            $where[] = ["step", "=", 2];
            $where[] = ["project", "=", 1];
            $where[] = ["active", "=", 1];
            $where[] = ["delete", "=", 0];
            $where[] = ["type", "=", $this->user["type"]];
            $where[] = ["isConditionFile", "<>", 1];
            $abroad_files = Db::table("new_common_filetype")->where($where)->select()->toArray(); //留学的附件
            $abroad_file_ids = null;
            if ($abroad_files)
                $abroad_file_ids = array_column($abroad_files, "id");

            if ($params["study_abroad"] == 1) {
                $no_empty[] = "abroad_school";
                $no_empty[] = "abroad_major";
            }
            if (in_array($params["source"], [1, 3])) {
                $no_empty[] = "source_batch";
                $no_empty[] = "fujian_highcert_pubtime";
                $no_empty[] = "fujian_highcert_exptime";
                if ($params["source"] == 3) {
                    $no_empty[] = "source_city";
                }
            }
            if (in_array($params["source"], [2, 4])) {
                $no_empty[] = "source_batch";
                $no_empty[] = "quanzhou_highcert_pubtime";
                $no_empty[] = "quanzhou_highcert_exptime";
                if ($params["source"] == 4) {
                    $no_empty[] = "source_county";
                }
            }

            $condition_info = Db::table("new_talent_condition")->findOrEmpty($params["talent_condition"]);

            if ($condition_info["isSalary"] == 1) {
                $no_empty[] = "annual_salary";
            }
            $no_empty = array_filter($no_empty);
            $return = [];
            foreach ($no_empty as $key) {
                if (!$params[$key]) {
                    $return[] = sprintf("请填写“%s”", $field_dict[$key]);
                }
            }
            if (count($return) > 0) {
                $res = ["msg" => implode("<br>", $return)];
                echo sprintf("<script>parent.TalentInfoInfoDlg.submitCallback(%s);</script>", json_encode($res));
                exit;
            }

            if ($condition_info["bindFileTypes"] && $info["source"] == 5) {
                $whr[] = ["id", "in", $condition_info["bindFileTypes"]];
                $whr[] = ["must", "=", 1];
            }
            $where = [];
            $where[] = ["step", "=", 2];
            $where[] = ["project", "=", 1];
            $where[] = ["type", "=", $this->user["type"]];
            $where[] = ["must", "=", 1];
            $where[] = ["active", "=", 1];
            $where[] = ["delete", "=", 0];
            $where[] = ["isConditionFile", "<>", 1];
            if ($whr) {
                $filetypes = Db::table("new_common_filetype")->whereOr([$where, $whr])->select()->toArray();
            } else {
                $filetypes = Db::table("new_common_filetype")->where($where)->select()->toArray();
            }
            $ft_ids = array_column($filetypes, "id");
            if ($params["study_abroad"] == 1) {
                //选中留学，如果存在留学附件变成必传
                $ft_ids = array_unique(array_merge($ft_ids, (array) $abroad_file_ids));
            } else {
                //没选中，留学附件就算设成必传也不用验证
                $ft_ids = array_diff($ft_ids, (array) $abroad_file_ids);
            }
            $whr = [];
            $whr[] = ["typeId", "in", $ft_ids];
            $whr[] = ["mainId", "=", $id];
            $distinct_filetypes = Db::table("new_talent_file")->where($whr)->distinct(true)->field("typeId")->select();
            $upload_type_counts = count($distinct_filetypes);
            if ($upload_type_counts != count($ft_ids)) {
                $res = ["msg" => "请留意附件上传栏中带*号的内容均为必传项，请上传完整再提交审核"];
                echo sprintf("<script>parent.TalentInfoInfoDlg.submitCallback(%s);</script>", json_encode($res));
                exit;
            }

            $this->save($info, $this->request, TalentState::SCND_SUBMIT);
        } else if (in_array($checkState, [TalentState::BASE_VERIFY_FAIL, TalentState::BASE_REVERIFY_FAIL, TalentState::FST_VERIFY_FAIL, TalentState::REVERIFY_FAIL])) {
            $res = ["msg" => "审核失败，不能再提交审核"];
            echo sprintf("<script>parent.TalentInfoInfoDlg.submitCallback(%s);</script>", json_encode($res));
            exit;
        }
        $res = ["msg" => "已提交审核，请耐心等待"];
        echo sprintf("<script>parent.TalentInfoInfoDlg.submitCallback(%s);</script>", json_encode($res));
        exit;
    }

    public function submitToCheck() {
        switch ($this->user["type"]) {
            case 1:
                return $this->submitToCheck_JJRC();
            case 2:
                return $this->submitToCheck_IC();
        }
    }

    /**
     * 提交表单（新：混合基础信息人才申报信息）晋江人才
     */
    private function submitToCheck_JJRC() {
        $params = $this->request->param();
        $id = $params["id"];
        $info = TalentApi::chkIsOwner($id, $this->user["uid"]);
        if ($info) {
            $info["real_state"] = TalentLogApi::getLastLog($id, 1)["state"];
        }
        $checkState = $info["checkState"];
        if ($checkState == TalentState::SCND_SAVE || !$id) {
            $field_dict = \app\common\api\DictApi::getTalentFields(4, $info["isImport"]);

            $no_empty = ["name", "nation", "card_type", "card_number", "sex", "birthday", "politics", "nationality", "province", "city", "talent_type", "experience", "education",
                "talent_arrange", "talent_condition", "bank", "bank_number", "bank_branch_name",
                "bank_account", "study_abroad", "phone", "email", "import_way", "cur_entry_time", "cur_entry_time", "position", "source"]; //"highest_degree", "graduate_school", "major",

            $where = [];
            $where[] = ["rel", "=", "study_abroad"];
            $where[] = ["project", "=", 1];
            $where[] = ["active", "=", 1];
            $where[] = ["delete", "=", 0];
            $where[] = ["type", "=", $this->user["type"]];
            $where[] = ["isConditionFile", "<>", 1];
            $abroad_files = Db::table("new_common_filetype")->where($where)->select()->toArray(); //留学的附件
            $abroad_file_ids = null;
            if ($abroad_files)
                $abroad_file_ids = array_column($abroad_files, "id");

            if (in_array($params["talent_type"], [1, 2])) {
                $no_empty[] = "tax_insurance_month";
                $no_empty[] = "labor_contract_rangetime";
            }
            if ($params["talent_type"] == 3) {
                $no_empty[] = "pre_import_type";
            }
            if ($params["study_abroad"] == 1) {
                $no_empty[] = "abroad_school";
                $no_empty[] = "abroad_major";
            }
            if (in_array($params["source"], [1, 3])) {
                //$no_empty[] = "source_batch";
                //$no_empty[] = "fujian_highcert_pubtime";
                //$no_empty[] = "fujian_highcert_exptime";
                if ($params["source"] == 3) {
                    $no_empty[] = "source_city";
                }
            }
            if (in_array($params["source"], [2, 4])) {
                //$no_empty[] = "source_batch";
                //$no_empty[] = "quanzhou_highcert_pubtime";
                //$no_empty[] = "quanzhou_highcert_exptime";
                if ($params["source"] == 4) {
                    $no_empty[] = "source_county";
                }
            }

            $condition_info = Db::table("new_talent_condition")->findOrEmpty($params["talent_condition"]);

            if ($condition_info["isSalary"] == 1) {
                $no_empty[] = "annual_salary";
            }
            $no_empty = array_filter($no_empty);
            $return = [];
            foreach ($no_empty as $key) {
                if (!$params[$key]) {
                    $return[] = sprintf("请填写“%s”", $field_dict[$key]);
                }
            }
            if (count($return) > 0) {
                $res = ["msg" => implode("<br>", $return)];
                echo sprintf("<script>parent.TalentInfoInfoDlg.submitCallback(%s);</script>", json_encode($res));
                exit;
            }
            $isMatchZhiren = $info["isImport"] && $params["isMatchZhiren"] == 1 ? true : false;
            if ($condition_info["bindFileTypes"] && $info["source"] == 5 && !$isMatchZhiren) {
                $whr[] = ["id", "in", $condition_info["bindFileTypes"]];
                $whr[] = ["must", "=", 1];
            }
            $where = [];
            $where[] = ["project", "=", 1];
            $where[] = ["type", "=", $this->user["type"]];
            $where[] = ["must", "=", 1];
            $where[] = ["active", "=", 1];
            $where[] = ["delete", "=", 0];
            $where[] = ["isConditionFile", "<>", 1];
            if ($whr) {
                $filetypes = Db::table("new_common_filetype")->whereOr([$where, $whr])->select()->toArray();
            } else {
                $filetypes = Db::table("new_common_filetype")->where($where)->select()->toArray();
            }
            $age = 0;
            if ($params["birthday"]) {
                $birthday = $params["birthday"];
                $birthdayYear = substr($birthday, 0, 4);
                $currentYear = date("Y");
                $age = $currentYear - $birthdayYear;
            }
            $ft_ids = [];
            $deletes = [];
            foreach ($filetypes as $ft) {
                if ($ft["option"]) {
                    if ($ft["rel"] == "birthday") {
                        if ($age < $ft["option"]) {
                            $deletes[] = $ft["id"];
                            continue;
                        }
                    } else {
                        $selectVal = $params[$ft["rel"]];
                        $conditions = array_filter(explode(",", $ft["option"]));
                        if (!in_array($selectVal, $conditions)) {
                            $deletes[] = $ft["id"];
                            continue;
                        }
                    }
                }
                $ft_ids[] = $ft["id"];
            }
            if ($params["study_abroad"] == 1) {
                //选中留学，如果存在留学附件变成必传
                $ft_ids = array_unique(array_merge($ft_ids, (array) $abroad_file_ids));
            } else {
                //没选中，留学附件就算设成必传也不用验证
                $ft_ids = array_diff($ft_ids, (array) $abroad_file_ids);
            }
            $whr = [];
            if ($id) {
                $whr[] = ["mainId", "=", $id];
            } else {
                if ($params["uploadFiles"])
                    $whr[] = ["id", "in", $params["uploadFiles"]];
            }
            $whr[] = ["typeId", "in", $ft_ids];
            $distinct_filetypes = Db::table("new_talent_file")->where($whr)->distinct(true)->field("typeId")->select();
            $upload_type_counts = count($distinct_filetypes);
            if ($upload_type_counts != count($ft_ids)) {
                $res = ["msg" => "请留意附件上传栏中带*号的内容均为必传项，请上传完整再提交审核"];
                echo sprintf("<script>parent.TalentInfoInfoDlg.submitCallback(%s);</script>", json_encode($res));
                exit;
            }

            return $this->mixSave($info, $this->request, TalentState::SCND_SUBMIT);
        } else if (in_array($checkState, [TalentState::BASE_VERIFY_FAIL, TalentState::BASE_REVERIFY_FAIL, TalentState::FST_VERIFY_FAIL, TalentState::REVERIFY_FAIL, TalentState::ZX_FAIL, TalentState::ANNOUNCED_REVERIFY_FAIL, TalentState::PUBLISH_FAIL])) {
            $res = ["msg" => "审核失败，不能再提交审核"];
            echo sprintf("<script>parent.TalentInfoInfoDlg.submitCallback(%s);</script>", json_encode($res));
            exit;
        }
        $res = ["msg" => "已提交审核，请耐心等待"];
        echo sprintf("<script>parent.TalentInfoInfoDlg.submitCallback(%s);</script>", json_encode($res));
        exit;
    }

    /**
     * 提交表单（新：混合基础信息人才申报信息）晋江电路
     */
    private function submitToCheck_IC() {
        $params = $this->request->param();
        $id = $params["id"];
        if (!$info = TalentApi::chkIsOwner($id, $this->user["uid"])) {
            return json(["msg" => "没有对应的人才认定申报信息"]);
        }
        if ($info) {
            $info["real_state"] = TalentLogApi::getLastLog($id, 1)["state"];
        }
        $checkState = $info["checkState"];
        if ($checkState == TalentState::SCND_SAVE) {
            $field_dict = \app\common\api\DictApi::getTalentFields_IC();

            $no_empty = ["name", "card_type", "card_number", "sex", "birthday", "nationality", "province", "city", "nation", "politics", "break_faith",
                "phone", "email", "highest_degree", "graduate_school", "major", "study_abroad", "position", "cur_entry_time", "labor_contract_rangetime",
                "talent_arrange", "talent_condition", "identifyConditionName", "identifyGetTime",
                "bank", "bank_branch_name", "bank_account", "experience", "education"];

            $no_empty = array_filter($no_empty);
            $return = [];
            foreach ($no_empty as $key) {
                if (!$info[$key]) {
                    $return[] = sprintf("请填写“%s”", $field_dict[$key]);
                }
            }
            if (count($return) > 0) {
                return json(["msg" => implode("<br>", $return)]);
            }

            $where = [];
            $where[] = ["project", "=", 1];
            $where[] = ["type", "=", $this->user["type"]];
            $where[] = ["must", "=", 1];
            $where[] = ["active", "=", 1];
            $where[] = ["delete", "=", 0];
            $filetypes = Db::table("new_common_filetype")->where($where)->select()->toArray();
            $ft_ids = array_column($filetypes, "id");
            $whr = [];
            $whr[] = ["typeId", "in", $ft_ids];
            $whr[] = ["mainId", "=", $id];
            $distinct_filetypes = Db::table("new_talent_file")->where($whr)->distinct(true)->field("typeId")->select();
            $upload_type_counts = count($distinct_filetypes);
            if ($upload_type_counts != count($ft_ids)) {
                return json(["msg" => "请留意附件上传栏中带*号的内容均为必传项，请上传完整再提交审核"]);
            }

            return $this->icSave($info, $this->request, TalentState::SCND_SUBMIT);
        } else if (in_array($checkState, [TalentState::BASE_VERIFY_FAIL, TalentState::BASE_REVERIFY_FAIL, TalentState::FST_VERIFY_FAIL, TalentState::REVERIFY_FAIL, TalentState::ZX_FAIL, TalentState::ANNOUNCED_REVERIFY_FAIL, TalentState::PUBLISH_FAIL])) {
            return json(["msg" => "审核失败，不能再提交审核", "code" => 500]);
        }
        return json(["msg" => "已提交审核，请耐心等待", "code" => 500]);
    }

    /**
     * 保存表单(旧第二步)
     * @param type $info talent_info
     * @param type $param request->param();
     */
    private function save($info, \think\Request $request, $checkState) {
        try {
            $batch = \app\common\api\BatchApi::getValidBatch(1, $this->user["type"]);
            if (!$batch) {
                throw new ValidateException("不在人才认定申报申请时间内");
            }
            $param = $request->param();
            validate(TalentInfo::class)->check($param);
            $data["apply_year"] = $batch["batch"];

            $all_valid_keys = ["applay_year", "import_way", "cur_entry_time", "position",
                "source", "source_batch", "fujian_highcert_pubtime", "fujian_highcert_exptime", "quanzhou_highcert_pubtime", "quanzhou_highcert_exptime", "source_city", "source_county",
                "talent_arrange", "talent_condition", "highest_degree", "graduate_school", "major", "professional", "bank", "bank_number", "bank_branch_name", "bank_account",
                "study_abroad", "abroad_school", "abroad_major", "phone", "email", "annual_salary", "pro_qua"];
            foreach ($all_valid_keys as $key) {
                $data[$key] = trim($param[$key]);
            }

            if ($data["study_abroad"] == 1) {
                $data["abroad_school"] = $param["abroad_school"];
                $data["abroad_major"] = $param["abroad_major"];
            } else {
                $data["abroad_school"] = null;
                $data["abroad_major"] = null;
            }
            switch ($data["source"]) {
                case 1:
                    $data["source_batch"] = $param["source_batch"];
                    $data["fujian_highcert_pubtime"] = $param["fujian_highcert_pubtime"];
                    $data["fujian_highcert_exptime"] = $param["fujian_highcert_exptime"];
                    $data["source_city"] = null;
                    break;
                case 2:
                    $data["source_batch"] = $param["source_batch"];
                    $data["quanzhou_highcert_pubtime"] = $param["quanzhou_highcert_pubtime"];
                    $data["quanzhou_highcert_exptime"] = $param["quanzhou_highcert_exptime"];
                    $data["source_county"] = null;
                    break;
                case 3:
                    $data["source_batch"] = $param["source_batch"];
                    $data["fujian_highcert_pubtime"] = $param["fujian_highcert_pubtime"];
                    $data["fujian_highcert_exptime"] = $param["fujian_highcert_exptime"];
                    $data["source_city"] = $param["source_city"];
                    break;
                case 4:
                    $data["source_batch"] = $param["source_batch"];
                    $data["quanzhou_highcert_pubtime"] = $param["quanzhou_highcert_pubtime"];
                    $data["quanzhou_highcert_exptime"] = $param["quanzhou_highcert_exptime"];
                    $data["source_county"] = $param["source_county"];
                    break;
            }

            $condition_info = Db::table("new_talent_condition")->findOrEmpty($param["talent_condition"]);
            if ($condition_info["isSalary"] == 1) {
                $data["annual_salary"] = $param["annual_salary"];
            } else {
                $data["annual_salary"] = null;
            }

            if ($info["real_state"] == TalentState::FST_VERIFY_REJECT) {
                //真实状态8是驳回，需要判断什么字段可以提交                
                $modify_fields = array_filter(explode(",", $info["modify_fields"]));
                $tmp_data = $data;
                $data = [];
                foreach ($modify_fields as $field) {
                    $data[$field] = $tmp_data[$field];
                }
            }
            $data["checkState"] = $checkState;
            $data["id"] = $info["id"];
            $success_msg = "提交成功";
            $error_msg = "提交失败";
            if ($checkState == TalentState::SCND_SAVE) {
                $last_log = TalentLogApi::getLastLog($data["id"], 1);
                if ($last_log["new_state"] != TalentState::SCND_SAVE) {
                    TalentLogApi::write(1, $data["id"], $checkState, "保存认定材料未提交", 1);
                }
                TalentModel::update($data);
            } else if ($checkState == TalentState::SCND_SUBMIT) {
                $success_msg = "提交成功";
                $error_msg = "提交失败";
                $data["new_submit_time"] = date("Y-m-d H:i:s");
                TalentModel::update($data);
                TalentLogApi::write(1, $info["id"], $checkState, "确认提交审核", 1);
            } else {
                throw new ValidateException($error_msg);
            }
            $res = ["code" => 200, "msg" => $success_msg, "obj" => ["id" => $info["id"], "checkState" => $checkState]];
            $callback = $checkState == TalentState::SCND_SAVE ? "infoCallback" : "submitCallback";
            echo sprintf("<script>parent.TalentInfoInfoDlg.{$callback}(%s);</script>", json_encode($res));
            exit();
        } catch (ValidateException $e) {
            $res = ["msg" => $e->getMessage()];
            $callback = $checkState == TalentState::SCND_SAVE ? "infoCallback" : "submitCallback";
            echo sprintf("<script>parent.TalentInfoInfoDlg.{$callback}(%s);</script>", json_encode($res));
            exit();
        }
    }

    /**
     * 保存表单(新：混合基础信息人才申报信息)
     * @param type $info talent_info
     * @param type $param request->param();
     */
    private function mixSave($info, \think\Request $request, $checkState) {
        try {
            $batch = \app\common\api\BatchApi::getValidBatch(1, $this->user["type"]);
            if (!$batch) {
                throw new ValidateException("不在人才认定申报申请时间内");
            }
            $param = $request->param();
            validate(TalentInfo::class)->check($param);
            $id = $param["id"];
            if ($id) {
                if (!$info || $info["id"] != $id || $info["enterprise_id"] != $this->user["uid"]) {
                    throw new ValidateException("没有对应的人才认定申报信息");
                }
            }
            $files = $param["uploadFiles"];
            $data["headimgurl"] = $info["headimgurl"];
            if ($request->file()) {
                $headimg = $request->file("photo");
                $upload = new \app\common\api\UploadApi();
                $result = $upload->uploadOne($headimg, "image", "talent/photo");
                $file = imagecreatefromstring(file_get_contents("storage/" . $result->filepath));
                $width = imagesx($file);
                $height = imagesy($file);
                //免冠二寸照长宽413：579
                if ($width * 579 != $height * 413) {
                    @unlink("storage/" . $result->filepath); //像素不符合，删除上传文件                    
                    throw new ValidateException("近期免冠半身彩照（二寸）不符合二寸像素标准。*<span style='color:#ff0000;'>二寸像素标准[413*579]</span>");
                }
                if ($info && $info["headimgurl"]) {
                    //如果新照片符合像素要求，则删除旧照片
                    $old_head_url = "storage/" . $info["headimgurl"];
                    if (file_exists($old_head_url))
                        @unlink($old_head_url);
                }
                $data["headimgurl"] = $result->filepath;
            }
            if (!$data["headimgurl"] && $checkState == TalentState::SCND_SUBMIT)
                throw new ValidateException("请上传头像。*<span style='color:#ff0000;'>二寸像素标准[413*579]</span>");

            $where = [];
            $where[] = ["project", "=", 1];
            $where[] = ["type", "=", $this->user["type"]];
            $where[] = ["must", "=", 1];
            $where[] = ["active", "=", 1];
            $where[] = ["delete", "=", 0];
            $filetypes = Db::table("new_common_filetype")->where($where)->select()->toArray();

            $age = 0;
            if ($param["birthday"]) {
                $birthday = $param["birthday"];
                $birthdayYear = substr($birthday, 0, 4);
                $currentYear = date("Y");
                $age = $currentYear - $birthdayYear;
            }
            $ft_ids = [];
            $deletes = [];
            foreach ($filetypes as $ft) {
                if ($ft["option"]) {
                    if ($ft["rel"] == "birthday") {
                        if ($age < $ft["option"]) {
                            $deletes[] = $ft["id"];
                            continue;
                        }
                    } else {
                        $selectVal = $param[$ft["rel"]];
                        $conditions = array_filter(explode(",", $ft["option"]));
                        if (!in_array($selectVal, $conditions)) {
                            $deletes[] = $ft["id"];
                            continue;
                        }
                    }
                }
                $ft_ids[] = $ft["id"];
            }

            $data["apply_year"] = $batch["batch"];
            $data["isMatchZhiren"] = $param["isMatchZhiren"] ?: 0;
            $all_valid_keys = ["talent_type", "name", "card_type", "card_number", "sex", "birthday", "nationality", "province", "city", "county", "nation", "politics", "experience", "education",
                "import_way", "cur_entry_time", "position",
                "source", "source_batch", "fujian_highcert_pubtime", "fujian_highcert_exptime", "quanzhou_highcert_pubtime", "quanzhou_highcert_exptime", "source_city", "source_county",
                "talent_arrange", "talent_condition", "highest_degree", "graduate_school", "major", "professional", "bank", "bank_number", "bank_branch_name", "bank_account",
                "study_abroad", "abroad_school", "abroad_major", "phone", "email", "annual_salary", "pro_qua"];
            foreach ($all_valid_keys as $key) {
                $data[$key] = trim($param[$key]);
            }
            $data["return"] = 0; //流出晋江满3年后又返回晋江的，只有talent_type=2时可以填写且非必填
            if (in_array($data["talent_type"], [1, 2])) {
                $data["tax_insurance_month"] = $param["tax_insurance_month"];
                $data["labor_contract_rangetime"] = $param["labor_contract_rangetime"];
                $data["salary_pay_way"] = $param["salary_pay_way"];
                $data["salary_pay_month"] = $param["salary_pay_month"];
                $data["fst_work_time"] = $param["fst_work_time"];
                $data['pre_import_type'] = null;
                if ($data["talent_type"] == 2) {
                    $data["return"] = $param["return"];
                }
            } else {
                $data["tax_insurance_month"] = null;
                $data["labor_contract_rangetime"] = null;
                $data["salary_pay_way"] = null;
                $data["salary_pay_month"] = null;
                $data["fst_work_time"] = null;
                $data['pre_import_type'] = $param["pre_import_type"];
            }

            if ($data["study_abroad"] == 1) {
                $data["abroad_school"] = $param["abroad_school"];
                $data["abroad_major"] = $param["abroad_major"];
            } else {
                $data["abroad_school"] = null;
                $data["abroad_major"] = null;
            }
            switch ($data["source"]) {
                case 1:
                    $data["source_batch"] = $param["source_batch"];
                    $data["fujian_highcert_pubtime"] = $param["fujian_highcert_pubtime"];
                    $data["fujian_highcert_exptime"] = $param["fujian_highcert_exptime"];
                    $data["source_city"] = null;
                    break;
                case 2:
                    $data["source_batch"] = $param["source_batch"];
                    $data["quanzhou_highcert_pubtime"] = $param["quanzhou_highcert_pubtime"];
                    $data["quanzhou_highcert_exptime"] = $param["quanzhou_highcert_exptime"];
                    $data["source_county"] = null;
                    break;
                case 3:
                    $data["source_batch"] = $param["source_batch"];
                    $data["fujian_highcert_pubtime"] = $param["fujian_highcert_pubtime"];
                    $data["fujian_highcert_exptime"] = $param["fujian_highcert_exptime"];
                    $data["source_city"] = $param["source_city"];
                    break;
                case 4:
                    $data["source_batch"] = $param["source_batch"];
                    $data["quanzhou_highcert_pubtime"] = $param["quanzhou_highcert_pubtime"];
                    $data["quanzhou_highcert_exptime"] = $param["quanzhou_highcert_exptime"];
                    $data["source_county"] = $param["source_county"];
                    break;
            }

            $condition_info = Db::table("new_talent_condition")->findOrEmpty($param["talent_condition"]);
            if ($condition_info["isSalary"] == 1) {
                $data["annual_salary"] = $param["annual_salary"];
            } else {
                $data["annual_salary"] = null;
            }
            if ($info["real_state"] == TalentState::FST_VERIFY_REJECT) {
                //真实状态11是驳回，需要判断什么字段可以提交                
                $modify_fields = array_filter(explode(",", $info["modify_fields"]));
                $tmp_data = $data;
                $data = [];
                foreach ($modify_fields as $field) {
                    $data[$field] = $tmp_data[$field];
                }
            }
            $data["checkState"] = $checkState;
            $data["id"] = $id;
            $success_msg = "提交成功";
            $error_msg = "提交失败";
            if ($checkState == TalentState::SCND_SAVE) {
                $success_msg = "保存成功";
                if ($data["id"]) {
                    //编辑
                    TalentModel::update($data);
                    $last_log = TalentLogApi::getLastLog($data["id"], 1);
                    if ($last_log["new_state"] != TalentState::SCND_SAVE) {
                        TalentLogApi::write(1, $data["id"], $checkState, "保存未提交", 1);
                    } else {
                        TalentLogApi::setActive($last_log["id"], 1); //更新修改时间
                    }
                } else {
                    //新增
                    $data["enterprise_id"] = $this->user["uid"];
                    $id = TalentModel::insertGetId($data);
                    TalentLogApi::write(1, $id, $checkState, "保存未提交", 1);
                    $whr = [];
                    $whr[] = ["fileId", "in", $files];
                    $upd_checklog["mainId"] = $id;
                    Db::table("new_talent_checklog")->where($whr)->save($upd_checklog);
                }
            } else if ($checkState == TalentState::SCND_SUBMIT) {
                if (!$info["first_submit_time"]) {
                    $data["first_submit_time"] = date("Y-m-d H:i:s");
                } else {
                    $data["new_submit_time"] = date("Y-m-d H:i:s");
                }
                if ($data["id"]) {
                    TalentModel::update($data);
                } else {
                    //新增
                    $data["enterprise_id"] = $this->user["uid"];
                    $id = TalentModel::insertGetId($data);
                    $whr = [];
                    $whr[] = ["fileId", "in", $files];
                    $upd_checklog["mainId"] = $id;
                    Db::table("new_talent_checklog")->where($whr)->save($upd_checklog);
                }
                TalentLogApi::write(1, $id, $checkState, "确认提交审核", 1);
            } else {
                throw new ValidateException($error_msg);
            }

            if ($id) {
                if ($deletes) {
                    //删除多余的附件，一般是选择人才类型留下来的
                    $whr = [];
                    $whr[] = ["typeId", "in", $deletes];
                    $whr[] = ["id", "in", $files];
                    $_wait_del_files = Db::table("new_talent_file")->where($whr)->select()->toArray();
                    $_logfileIds[] = [];
                    foreach ($_wait_del_files as $_del_file) {
                        $_logfileIds[] = $_del_file["id"];
                        @unlink("storage/" . $_del_file["url"]);
                    }
                    Db::table("new_talent_file")->where($whr)->delete();
                    if ($_logfileIds) {
                        $whr = [];
                        $whr[] = ["fileId", "in", $_logfileIds];
                        $_upd_checklog["description"] = "删除附件";
                        $_upd_checklog["updateUser"] = sprintf("%s(%s)", $this->user["account"], $this->user["companyName"] ?: $this->user["rolename"]);
                        $_upd_checklog["updateTime"] = date("Y-m-d H:i:s");
                        Db::table("new_talent_checklog")->where($whr)->save($_upd_checklog);
                    }
                }

                $whr = [];
                $whr[] = ["id", "in", $files];
                Db::table("new_talent_file")->where($whr)->save(["mainId" => $id]);
                $res = ["code" => 200, "msg" => $success_msg, "obj" => ["id" => $id, "checkState" => $checkState]];
                $callback = $checkState == TalentState::SCND_SAVE ? "infoCallback" : "submitCallback";
                echo sprintf("<script>parent.TalentInfoInfoDlg.{$callback}(%s);</script>", json_encode($res));
                exit();
            } else {
                throw new ValidateException($error_msg);
            }
        } catch (ValidateException $e) {
            $res = ["msg" => $e->getMessage()];
            $callback = $checkState == TalentState::SCND_SAVE ? "infoCallback" : "submitCallback";
            echo sprintf("<script>parent.TalentInfoInfoDlg.{$callback}(%s);</script>", json_encode($res));
            exit();
        } catch (\think\Exception $e) {
            $res = ["msg" => "发生预料外错误，请联系管理员处理，错误代码：" . $e->getCode()];
            $logInfo = [
                "enterprise_id" => $this->user["uid"],
                "data" => $data,
                "controller" => $this->request->controller(),
                "action" => $this->request->action(),
                "errCode" => $e->getCode(),
                "errMsg" => $e->getMessage()
            ];
            Log::write($logInfo, "error");
            $callback = $checkState == TalentState::SCND_SAVE ? "infoCallback" : "submitCallback";
            echo sprintf("<script>parent.TalentInfoInfoDlg.{$callback}(%s);</script>", json_encode($res));
            exit();
        }
    }

    private function icSave($info, \think\Request $request, $checkState) {
        try {
            $batch = \app\common\api\BatchApi::getValidBatch(1, $this->user["type"]);
            if (!$batch) {
                throw new ValidateException("不在人才认定申报申请时间内");
            }
            $param = $request->param();
            validate(TalentInfo::class)->check($param);
            $id = $param["id"];
            if ($id) {
                if (!$info || $info["id"] != $id || $info["enterprise_id"] != $this->user["uid"]) {
                    throw new ValidateException("没有对应的人才认定申报信息");
                }
            }
            $files = $param["uploadFiles"];
            $data["headimgurl"] = $info["headimgurl"];
            if ($request->file()) {
                $headimg = $request->file("photo");
                $upload = new \app\common\api\UploadApi();
                $result = $upload->uploadOne($headimg, "image", "talent/photo");
                $file = imagecreatefromstring(file_get_contents("storage/" . $result->filepath));
                $width = imagesx($file);
                $height = imagesy($file);
                //免冠二寸照长宽413：579
                if ($width * 579 != $height * 413) {
                    @unlink("storage/" . $result->filepath); //像素不符合，删除上传文件                    
                    throw new ValidateException("近期免冠半身彩照（二寸）不符合二寸像素标准。*<span style='color:#ff0000;'>二寸像素标准[413*579]</span>");
                }
                if ($info && $info["headimgurl"]) {
                    //如果新照片符合像素要求，则删除旧照片
                    $old_head_url = "storage/" . $info["headimgurl"];
                    if (file_exists($old_head_url))
                        @unlink($old_head_url);
                }
                $data["headimgurl"] = $result->filepath;
            }
            if (!$data["headimgurl"] && $checkState == TalentState::SCND_SUBMIT)
                throw new ValidateException("请上传头像。*<span style='color:#ff0000;'>二寸像素标准[413*579]</span>");

            $data["apply_year"] = $batch["batch"];

            $all_valid_keys = ["name", "card_type", "card_number", "sex", "birthday", "nationality", "province", "city", "county", "nation", "politics", "experience", "education", "break_faith",
                "phone", "email", "highest_degree", "graduate_school", "major", "study_abroad",
                "position", "cur_entry_time", "labor_contract_rangetime",
                "talent_arrange", "talent_condition", "identifyConditionName", "identifyGetTime", "title", "pro_qua",
                "bank", "bank_branch_name", "bank_account", "description"];
            foreach ($all_valid_keys as $key) {
                $value = trim($param[$key]);
                if ($value) {
                    $data[$key] = $value;
                }
            }

            if ($info["real_state"] == TalentState::FST_VERIFY_REJECT) {
                //真实状态11是驳回，需要判断什么字段可以提交                
                $modify_fields = array_filter(explode(",", $info["modify_fields"]));
                $tmp_data = $data;
                $data = [];
                foreach ($modify_fields as $field) {
                    $data[$field] = $tmp_data[$field];
                }
            }
            $data["checkState"] = $checkState;
            $data["id"] = $id;
            $success_msg = "提交成功";
            $error_msg = "提交失败";
            if ($checkState == TalentState::SCND_SAVE) {
                $success_msg = "保存成功";
                if ($data["id"]) {
                    //编辑
                    TalentModel::update($data);
                    $last_log = TalentLogApi::getLastLog($data["id"], 1);
                    if ($last_log["new_state"] != TalentState::SCND_SAVE) {
                        TalentLogApi::write(1, $data["id"], $checkState, "保存未提交", 1);
                    } else {
                        TalentLogApi::setActive($last_log["id"], 1); //更新修改时间
                    }
                } else {
                    //新增
                    $data["enterprise_id"] = $this->user["uid"];
                    $id = TalentModel::insertGetId($data);
                    TalentLogApi::write(1, $id, $checkState, "保存未提交", 1);
                    $whr = [];
                    $whr[] = ["fileId", "in", $files];
                    $upd_checklog["mainId"] = $id;
                    Db::table("new_talent_checklog")->where($whr)->save($upd_checklog);
                }
                $res = ["code" => 200, "msg" => $success_msg, "obj" => ["id" => $id, "checkState" => $checkState]];
                echo sprintf("<script>parent.TalentInfoInfoDlg.infoCallback(%s);</script>", json_encode($res));
                exit();
            } else if ($checkState == TalentState::SCND_SUBMIT) {
                $data["new_submit_time"] = date("Y-m-d H:i:s");
                TalentModel::update($data);
                TalentLogApi::write(1, $data["id"], $checkState, "确认提交审核", 1);
                return json(["msg" => $success_msg, "code" => 200]);
            } else {
                throw new ValidateException($error_msg);
            }
        } catch (ValidateException $e) {
            if ($checkState == TalentState::SCND_SAVE) {
                $res = ["msg" => $e->getMessage()];
                echo sprintf("<script>parent.TalentInfoInfoDlg.infoCallback(%s);</script>", json_encode($res));
                exit();
            } else {
                return json(["msg" => $e->getMessage()]);
            }
        } catch (\think\Exception $e) {
            $res = ["msg" => "发生预料外错误，请联系管理员处理，错误代码：" . $e->getCode()];
            $logInfo = [
                "enterprise_id" => $this->user["uid"],
                "data" => $data,
                "controller" => $this->request->controller(),
                "action" => $this->request->action(),
                "errCode" => $e->getCode(),
                "errMsg" => $e->getMessage()
            ];
            Log::write($logInfo, "error");
            if ($checkState == TalentState::SCND_SAVE) {
                echo sprintf("<script>parent.TalentInfoInfoDlg.infoCallback(%s);</script>", json_encode($res));
                exit();
            } else {
                return json($res);
            }
        }
    }

    public function delete() {
        $id = $this->request->param("talentInfoId");
        $info = Talent::chkIsOwner($id, $this->user["uid"]);
        if (!$info) {
            return json(["msg" => "操作失败"]);
        }
        $checkState = $info["checkState"];
        if (in_array($checkState, [0, 1])) {
            $log = TalentLogApi::getLastLog($id, 1);
            if ($log["state"] > 1) {
                //有提交审核记录
                return json(["msg" => "该申报已提交审核,无法删除"]);
            }
        }
        $data["id"] = $id;
        $data["delete"] = 1;
        TalentModel::update($data);
        return json(["msg" => "删除成功"]);
    }

    public function mixDelete() {
        $id = $this->request->param("talentInfoId");
        $info = Talent::chkIsOwner($id, $this->user["uid"]);
        if (!$info) {
            return json(["msg" => "操作失败"]);
        }
        $checkState = $info["checkState"];
        if (in_array($checkState, [0, TalentState::SCND_SAVE])) {
            $log = TalentLogApi::getLastLog($id, 1);
            if ($log["state"] > 1) {
                //有提交审核记录
                return json(["msg" => "该申报已提交审核,无法删除"]);
            }
        }
        $data["id"] = $id;
        $data["delete"] = 1;
        TalentModel::update($data);
        return json(["msg" => "删除成功"]);
    }

}
